Remove a useless SCCS marker
[privoxy.git] / privoxy-generic.init
1 #!/bin/sh 
2
3 #  ********************************************************************
4
5 #  File        :  $Source: /cvsroot/ijbswa/current/privoxy-generic.init,v $
6
7 #  Purpose     :  This shell script takes care of starting and stopping
8 #                 privoxy.
9
10 #  Copyright   :  Written by and Copyright (C) 2001,2002 the SourceForge
11 #                 Privoxy team. http://www.privoxy.org/
12
13 #                 Based on the Internet Junkbuster originally written
14 #                 by and Copyright (C) 1997 Anonymous Coders and
15 #                 Junkbusters Corporation.  http://www.junkbusters.com
16
17 #                 This program is free software; you can redistribute it
18 #                 and/or modify it under the terms of the GNU General
19 #                 Public License as published by the Free Software
20 #                 Foundation; either version 2 of the License, or (at
21 #                 your option) any later version.
22
23 #                 This program is distributed in the hope that it will
24 #                 be useful, but WITHOUT ANY WARRANTY; without even the
25 #                 implied warranty of MERCHANTABILITY or FITNESS FOR A
26 #                 PARTICULAR PURPOSE.  See the GNU General Public
27 #                 License for more details.
28
29 #                 The GNU General Public License should be included with
30 #                 this file.  If not, you can view it at
31 #                 http://www.gnu.org/copyleft/gpl.html
32 #                 or write to the Free Software Foundation, Inc., 59
33 #                 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
34 #
35 # Developer's NOTE: This script should be tested against a true /bin/sh, which
36 # has notable differences from bash. By design, this script does not try to do
37 # too much, so as to be as cross-platform as possible.
38 #
39 #######################################################################
40
41 # NOTE: This script may require editing to ensure proper location of 
42 # config file, and the privoxy executable. Care should be taken to ensure 
43 # logfile is writable by $P_USER (logfile is defined in config), and that 
44 # there is suitable write access for $P_PIDFILE.
45
46 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/xpg4/bin:/usr/bin:/sbin:/bin
47 P_NAME=Privoxy
48 # Path to executable.
49 P_DAEMON=privoxy
50 # Full path to location of Privoxy config file. 
51 P_CONF_FILE=/usr/local/etc/privoxy/config
52 # Full path to PID file location. Location must be writable by 
53 # whoever runs this script and by Privoxy itself.
54 P_PIDFILE=/var/run/privoxy.pid
55 # If uncommented, this script will try to run as USER=privoxy, which
56 # may require special handling of config, *.action, trust, logfile, 
57 # jarfile, and pidfile.
58 P_USER=privoxy
59
60 # If a privoxy user is specified, lets try that. /bin/sh does not seem to 
61 # know about $UID.
62 if [ 0 = `id -u` ]; then
63   if [ -n "$P_USER" ]; then
64     id $P_USER 2>/dev/null >/dev/null
65     if [ $? -eq 0 ]; then
66       P_USER_SETTINGS="--user $P_USER"
67     else
68       echo "User $P_USER doesn't exist, exiting."
69       exit 1
70     fi 
71   else
72     # The user has sufficient rights, but $P_USER isn't set
73     echo "Running Privoxy as root is not recommended!" 
74     P_USER_SETTINGS=""
75   fi
76 else
77   # The user has insufficient rights to run Privoxy as $P_USER
78   # and may not be able to write or delete the PID file.
79   echo "You aren't root, expect trouble!"
80   P_USER_SETTINGS=""
81 fi
82
83 if [ ! -f $P_CONF_FILE ]; then
84   echo "Can't find $P_CONF_FILE, exiting."
85   exit 1
86 fi
87
88 case "$1" in
89  
90  start)
91      if [ -f $P_PIDFILE ]; then
92        if kill -0 `cat $P_PIDFILE`; then
93          echo "Error: $P_NAME is already running, exiting."
94          exit 1
95        else
96          rm -f $P_PIDFILE
97        fi
98      fi
99
100         $P_DAEMON --pidfile $P_PIDFILE $P_USER_SETTINGS $P_CONF_FILE 2>/dev/null
101      
102      if [ $? -eq 0 ]; then
103        echo "Starting $P_NAME, OK." 
104      else
105        echo "Starting $P_NAME, Failed."
106        rm -f $P_PIDFILE
107      fi
108      ;;
109  
110  restart)
111      $0 stop
112      $0 start
113      ;;
114  
115  stop)
116      test ! -f $P_PIDFILE && echo "No $P_PIDFILE file found, exiting." && exit 1
117      kill `cat $P_PIDFILE` && rm -f $P_PIDFILE && \
118      echo "Stopping $P_NAME, OK." || echo "Stopping $P_NAME, failed."
119      ;;
120  
121  *)
122      echo "Usage: $0 {start|stop|restart}"
123      exit 1
124      ;;
125
126 esac
127
128 exit 0